<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-row dense>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="name"
              v-model="obj.name"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartAssemblyName')"
              :rules="[form().required(this, 'name')]"
              :error-messages="form().serverErrors(this, 'name')"
              data-cy="name"
              @input="fieldValueChanged('name')"
            ></v-text-field>
          </v-col>

          <!-- ################################ PARTS ############################### -->
          <v-col cols="12" class="mb-10">
            <span class="text-subtitle-2"> {{ $ay.t("PartList") }}</span
            ><v-btn v-if="!formState.readOnly" large icon @click="addItem()">
              <v-icon small color="primary">$ayiPlus</v-icon>
            </v-btn>

            <v-simple-table>
              <template v-slot:default>
                <thead>
                  <tr>
                    <th class="text-left">
                      {{ $ay.t("Part") }}
                    </th>
                    <th class="text-right">
                      {{ $ay.t("WorkOrderItemPartQuantity") }}
                    </th>
                    <th></th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    v-for="(item, index) in obj.items"
                    :key="item.Id"
                    :class="form().childRowErrorClass(thisVm(), 'Items', index)"
                  >
                    <td class="text-left">
                      {{ item.partNameViz }}
                    </td>
                    <th class="text-right">
                      {{ $ay.dec(item.quantity) }}
                    </th>

                    <td class="text-right">
                      <v-btn
                        v-if="!formState.readOnly"
                        large
                        icon
                        class="ml-4"
                        @click="editItem(index)"
                      >
                        <v-icon small>
                          $ayiEdit
                        </v-icon>
                      </v-btn>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-checkbox
              ref="active"
              v-model="obj.active"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('Active')"
              data-cy="active"
              :error-messages="form().serverErrors(this, 'active')"
              @change="fieldValueChanged('active')"
            ></v-checkbox>
          </v-col>
          <!-- --------------------------------- -->
          <v-col v-if="form().showMe(this, 'Notes')" cols="12">
            <v-textarea
              ref="notes"
              v-model="obj.notes"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartAssemblyNotes')"
              :error-messages="form().serverErrors(this, 'notes')"
              data-cy="notes"
              auto-grow
              @input="fieldValueChanged('notes')"
            ></v-textarea>
          </v-col>

          <v-col v-if="form().showMe(this, 'Tags')" cols="12">
            <gz-tag-picker
              ref="tags"
              v-model="obj.tags"
              :readonly="formState.readOnly"
              data-cy="tags"
              :error-messages="form().serverErrors(this, 'tags')"
              @input="fieldValueChanged('tags')"
            ></gz-tag-picker>
          </v-col>

          <v-col cols="12">
            <gz-custom-fields
              ref="customFields"
              v-model="obj.customFields"
              :form-key="formCustomTemplateKey"
              :readonly="formState.readOnly"
              :parent-v-m="this"
              data-cy="customFields"
              :error-messages="form().serverErrors(this, 'customFields')"
              @input="fieldValueChanged('customFields')"
            ></gz-custom-fields>
          </v-col>

          <v-col v-if="form().showMe(this, 'Wiki')" cols="12">
            <gz-wiki
              ref="wiki"
              v-model="obj.wiki"
              :aya-type="ayaType"
              :aya-id="obj.id"
              :readonly="formState.readOnly"
              @input="fieldValueChanged('wiki')"
            ></gz-wiki
          ></v-col>

          <v-col v-if="form().showMe(this, 'Attachments') && obj.id" cols="12">
            <gz-attachments
              :readonly="formState.readOnly"
              :aya-type="ayaType"
              :aya-id="obj.id"
            ></gz-attachments
          ></v-col>
        </v-row>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
    <!-- #########################################################################################################-->
    <!-- ##########################  ITEM EDIT FORM  ###############################-->
    <!-- #########################################################################################################-->
    <template v-if="obj.items.length && editItemIndex != -1">
      <v-row dense justify="center">
        <v-dialog v-model="editItemDialog" max-width="800">
          <v-card>
            <v-card-title> </v-card-title>
            <v-card-text>
              <v-row dense>
                <v-col cols="12" sm="8">
                  <gz-pick-list
                    ref="userid"
                    v-model="obj.items[editItemIndex].partId"
                    :allow-no-selection="false"
                    :can-clear="false"
                    :aya-type="ayaTypes().Part"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('Part')"
                    data-cy="userid"
                    :rules="[
                      form().integerValid(this, 'Items.PartId'),
                      form().required(this, 'Items.PartId')
                    ]"
                    :error-messages="
                      form().serverErrors(
                        this,
                        `Items[${editItemIndex}].PartId`
                      )
                    "
                    :name.sync="obj.items[editItemIndex].partNameViz"
                    @input="fieldValueChanged(`Items[${editItemIndex}].PartId`)"
                  ></gz-pick-list>
                </v-col>

                <v-col cols="12" sm="4">
                  <gz-decimal
                    ref="Items.Quantity"
                    v-model="obj.items[editItemIndex].quantity"
                    :readonly="formState.readOnly"
                    :label="$ay.t('WorkOrderItemPartQuantity')"
                    data-cy="Items.Quantity"
                    :rules="[
                      form().decimalValid(this, 'Items.Quantity'),
                      form().required(this, 'Items.Quantity')
                    ]"
                    :error-messages="
                      form().serverErrors(
                        this,
                        `Items[${editItemIndex}].Quantity`
                      )
                    "
                    @input="
                      fieldValueChanged(`Items[${editItemIndex}].Quantity`)
                    "
                  ></gz-decimal>
                </v-col>
              </v-row>
            </v-card-text>
            <v-card-actions>
              <template v-if="!$vuetify.breakpoint.xs">
                <v-btn
                  v-if="adding"
                  color="red darken-1"
                  text
                  @click="deleteItem()"
                  >{{ $ay.t("Cancel") }}</v-btn
                >
                <v-btn v-else color="red darken-1" text @click="deleteItem()">{{
                  $ay.t("Delete")
                }}</v-btn>
                <v-spacer></v-spacer>

                <!-- <v-btn
                  color="blue darken-1"
                  text
                  class="ml-4"
                  @click="addItem()"
                  >{{ $ay.t("New") }}</v-btn
                > -->

                <v-btn
                  color="blue darken-1"
                  text
                  class="ml-4"
                  @click="okClicked()"
                  >{{ $ay.t("OK") }}</v-btn
                >
              </template>
              <template v-else>
                <!-- MOBILE FORMAT -->
                <v-row dense>
                  <v-btn
                    class="mt-4"
                    block
                    text
                    color="blue darken-1"
                    @click="okClicked()"
                    >{{ $ay.t("OK") }}</v-btn
                  >
                  <!-- <v-btn
                    class="mt-4"
                    block
                    text
                    color="blue darken-1"
                    @click="addItem()"
                    >{{ $ay.t("New") }}</v-btn
                  > -->

                  <v-btn
                    v-if="adding"
                    class="mt-8 mb-6"
                    block
                    text
                    color="red darken-1"
                    @click="deleteItem()"
                    >{{ $ay.t("Cancel") }}</v-btn
                  >
                  <v-btn
                    v-else
                    class="mt-8 mb-6"
                    block
                    text
                    color="red darken-1"
                    @click="deleteItem()"
                    >{{ $ay.t("Delete") }}</v-btn
                  >
                </v-row>
              </template>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </template>
  </div>
</template>
<script>
const FORM_KEY = "part-assembly-edit";
const API_BASE_URL = "part-assembly/";
const FORM_CUSTOM_TEMPLATE_KEY = "PartAssembly";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      obj: {
        id: 0,
        concurrency: 0,
        name: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        items: []
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.PartAssembly,
      selectedPart: null,
      editItemDialog: false,
      editItemIndex: 0,
      adding: false
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.PartAssembly);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          this.obj.name = `${this.obj.name} - ${window.$gz.translation.get(
            "Copy"
          )}`;
          this.obj.items.forEach(z => (z.id = 0));
          setDirty = true;
        }
      }

      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    okClicked: function() {
      //if nothing selected then remove this empty record
      if (this.obj.items[this.editItemIndex].partId == null) {
        this.deleteItem();
      }
      this.editItemDialog = false;
    },
    addItem: function() {
      this.editItemIndex =
        this.obj.items.push({
          id: 0,
          partAssemblyId: this.obj.id,
          partId: null
        }) - 1;
      this.adding = true;
      this.editItemDialog = true;
      this.formState.dirty = true;
    },
    editItem: function(index) {
      this.adding = false;
      this.editItemIndex = index;
      this.editItemDialog = true;
    },
    deleteItem: function() {
      this.editItemDialog = false;
      this.obj.items.splice(this.editItemIndex, 1);
      this.editItemIndex = -1;
      this.formState.dirty = true;
    },
    openItem: function(item) {
      window.$gz.eventBus.$emit("openobject", {
        type: window.$gz.type.Part,
        id: item.partId
      });
    },
    quantityChanged: function(item) {
      const vm = this;
      if (item.quantity == null || item.quantity < 1) {
        const index = vm.obj.items.findIndex(z => z.partId == item.partId);
        if (index == -1) {
          return;
        }
        item.quantity = 1;
      }
      vm.formState.dirty = true;
    },
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    thisVm() {
      return this;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "part-assembly-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          const url = API_BASE_URL + this.$route.params.recordid;
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(url);
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    duplicate() {
      this.$router.push({
        name: "part-assembly-edit",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "part-assembly-edit",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.PartAssembly,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;

      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiObjectGroup",
    title: "PartAssembly",
    helpUrl: "inv-part-assemblies",
    formData: {
      ayaType: window.$gz.type.PartAssembly,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName: vm.obj.name
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$ayiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }

  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "PartAssembly",
    "PartAssemblyName",
    "PartAssemblyNotes",
    "PartList",
    "Part",
    "PartName",
    "WorkOrderItemPartQuantity",
    "PartAssemblyCustom1",
    "PartAssemblyCustom2",
    "PartAssemblyCustom3",
    "PartAssemblyCustom4",
    "PartAssemblyCustom5",
    "PartAssemblyCustom6",
    "PartAssemblyCustom7",
    "PartAssemblyCustom8",
    "PartAssemblyCustom9",
    "PartAssemblyCustom10",
    "PartAssemblyCustom11",
    "PartAssemblyCustom12",
    "PartAssemblyCustom13",
    "PartAssemblyCustom14",
    "PartAssemblyCustom15",
    "PartAssemblyCustom16"
  ]);
}
</script>
